#!/usr/bin/env python

#
# DM PROC Web Service
#

from dm.common.service.dmRestWebServiceBase import DmRestWebServiceBase
from dm.common.utility.dmModuleManager import DmModuleManager
from dm.common.utility.configurationManager import ConfigurationManager

from procWebServiceRouteMapper import ProcWebServiceRouteMapper

class ProcWebService(DmRestWebServiceBase):

    def __init__(self):
        DmRestWebServiceBase.__init__(self, ProcWebServiceRouteMapper)

    def initDmModules(self):
        self.logger.debug('Initializing dm modules')

        # Add modules that will be started.
        moduleManager = DmModuleManager.getInstance()

        self.logger.debug('Initialized dm modules')

    def getDefaultServerHost(self):
        return ConfigurationManager.getInstance().getServiceHost()

    def getDefaultServerPort(self):
        return ConfigurationManager.getInstance().getServicePort()

####################################################################
# Run service

if __name__ == '__main__':
    ConfigurationManager.getInstance().setServiceName('proc-web-service')
    service = ProcWebService();
    service.run()
