package gov.anl.aps.dm.common.exceptions;

import gov.anl.aps.dm.common.constants.DmStatus;

/**
 * Internal error exception.
 */
public class InternalError extends DmException {

    /**
     * Default constructor.
     */
    public InternalError() {
        super();
    }

    /**
     * Constructor using error message.
     *
     * @param message error message
     */
    public InternalError(String message) {
        super(message);
    }

    /**
     * Constructor using throwable object.
     *
     * @param throwable throwable object
     */
    public InternalError(Throwable throwable) {
        super(throwable);
    }

    /**
     * Constructor using error message and throwable object.
     *
     * @param message error message
     * @param throwable throwable object
     */
    public InternalError(String message, Throwable throwable) {
        super(message, throwable);
    }
    
    @Override
    public int getErrorCode() {
        return DmStatus.DM_INTERNAL_ERROR;
    }
}
