package gov.anl.aps.dm.common.exceptions;

import gov.anl.aps.dm.common.constants.DmStatus;

/**
 * Object already exists exception.
 */
public class ObjectAlreadyExists extends DmException {

    /**
     * Default constructor.
     */
    public ObjectAlreadyExists() {
        super();
    }

    /**
     * Constructor using error message.
     *
     * @param message error message
     */
    public ObjectAlreadyExists(String message) {
        super(message);
    }

    /**
     * Constructor using throwable object.
     *
     * @param throwable throwable object
     */
    public ObjectAlreadyExists(Throwable throwable) {
        super(throwable);
    }

    /**
     * Constructor using error message and throwable object.
     *
     * @param message error message
     * @param throwable throwable object
     */
    public ObjectAlreadyExists(String message, Throwable throwable) {
        super(message, throwable);
    }

    @Override
    public int getErrorCode() {
        return DmStatus.DM_OBJECT_ALREADY_EXISTS;
    }    
}
