/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.anl.aps.dm.portal.model.beans;

import gov.anl.aps.dm.portal.model.entities.UserExperimentRole;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;

/**
 *
 * @author sveseli
 */
@Stateless
public class UserExperimentRoleDbFacade extends DmEntityDbFacade<UserExperimentRole> {

    @PersistenceContext(unitName = "DmWebPortalPU")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public UserExperimentRoleDbFacade() {
        super(UserExperimentRole.class);
    }

    public UserExperimentRole findByUserAndExperiment(int userId, int experimentId) {
        try {
            return (UserExperimentRole) em.createNamedQuery("UserExperimentRole.findByUserAndExperiment")
                    .setParameter("userId", userId)
                    .setParameter("experimentId", experimentId)
                    .getSingleResult();
        } catch (NoResultException ex) {
        }
        return null;
    }
    
    public UserExperimentRole findByUserAndExperimentAndRoleType(int userId, int experimentId, int roleTypeId) {
        try {
            return (UserExperimentRole) em.createNamedQuery("UserExperimentRole.findByUserAndExperimentAndRoleType")
                    .setParameter("userId", userId)
                    .setParameter("experimentId", experimentId)
                    .setParameter("roleTypeId", roleTypeId)
                    .getSingleResult();
        } catch (NoResultException ex) {
        }
        return null;
    }

}
