/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.anl.aps.dm.portal.model.entities;

import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author sveseli
 */
@Entity
@Table(name = "experiment_policy_property_value")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "ExperimentPolicyPropertyValue.findAll", query = "SELECT e FROM ExperimentPolicyPropertyValue e")
    , @NamedQuery(name = "ExperimentPolicyPropertyValue.findById", query = "SELECT e FROM ExperimentPolicyPropertyValue e WHERE e.id = :id")
    , @NamedQuery(name = "ExperimentPolicyPropertyValue.findByModifiedBy", query = "SELECT e FROM ExperimentPolicyPropertyValue e WHERE e.modifiedBy = :modifiedBy")
    , @NamedQuery(name = "ExperimentPolicyPropertyValue.findByModifiedDate", query = "SELECT e FROM ExperimentPolicyPropertyValue e WHERE e.modifiedDate = :modifiedDate")
    , @NamedQuery(name = "ExperimentPolicyPropertyValue.findByPolicyPropertyValue", query = "SELECT e FROM ExperimentPolicyPropertyValue e WHERE e.policyPropertyValue = :policyPropertyValue")})
public class ExperimentPolicyPropertyValue extends DmEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    private Integer id;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 2147483647)
    @Column(name = "modified_by")
    private String modifiedBy;
    @Basic(optional = false)
    @NotNull
    @Column(name = "modified_date")
    @Temporal(TemporalType.DATE)
    private Date modifiedDate;
    @Size(max = 2147483647)
    @Column(name = "policy_property_value")
    private String policyPropertyValue;
    @JoinColumn(name = "experiment_policy_id", referencedColumnName = "id")
    @ManyToOne(optional = false)
    private ExperimentPolicy experimentPolicyId;
    @JoinColumn(name = "policy_property_id", referencedColumnName = "id")
    @ManyToOne(optional = false)
    private PolicyProperty policyPropertyId;

    public ExperimentPolicyPropertyValue() {
    }

    public ExperimentPolicyPropertyValue(Integer id) {
        this.id = id;
    }

    public ExperimentPolicyPropertyValue(Integer id, String modifiedBy, Date modifiedDate) {
        this.id = id;
        this.modifiedBy = modifiedBy;
        this.modifiedDate = modifiedDate;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getModifiedBy() {
        return modifiedBy;
    }

    public void setModifiedBy(String modifiedBy) {
        this.modifiedBy = modifiedBy;
    }

    public Date getModifiedDate() {
        return modifiedDate;
    }

    public void setModifiedDate(Date modifiedDate) {
        this.modifiedDate = modifiedDate;
    }

    public String getPolicyPropertyValue() {
        return policyPropertyValue;
    }

    public void setPolicyPropertyValue(String policyPropertyValue) {
        this.policyPropertyValue = policyPropertyValue;
    }

    public ExperimentPolicy getExperimentPolicyId() {
        return experimentPolicyId;
    }

    public void setExperimentPolicyId(ExperimentPolicy experimentPolicyId) {
        this.experimentPolicyId = experimentPolicyId;
    }

    public PolicyProperty getPolicyPropertyId() {
        return policyPropertyId;
    }

    public void setPolicyPropertyId(PolicyProperty policyPropertyId) {
        this.policyPropertyId = policyPropertyId;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof ExperimentPolicyPropertyValue)) {
            return false;
        }
        ExperimentPolicyPropertyValue other = (ExperimentPolicyPropertyValue) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "gov.anl.aps.dm.portal.model.entities2.ExperimentPolicyPropertyValue[ id=" + id + " ]";
    }
    
}
