/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.anl.aps.dm.portal.model.entities;

import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author sveseli
 */
@Entity
@Table(name = "policy_property")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "PolicyProperty.findAll", query = "SELECT p FROM PolicyProperty p")
    , @NamedQuery(name = "PolicyProperty.findById", query = "SELECT p FROM PolicyProperty p WHERE p.id = :id")
    , @NamedQuery(name = "PolicyProperty.findByName", query = "SELECT p FROM PolicyProperty p WHERE p.name = :name")
    , @NamedQuery(name = "PolicyProperty.findByUnits", query = "SELECT p FROM PolicyProperty p WHERE p.units = :units")
    , @NamedQuery(name = "PolicyProperty.findByLowerLimit", query = "SELECT p FROM PolicyProperty p WHERE p.lowerLimit = :lowerLimit")
    , @NamedQuery(name = "PolicyProperty.findByUpperLimit", query = "SELECT p FROM PolicyProperty p WHERE p.upperLimit = :upperLimit")
    , @NamedQuery(name = "PolicyProperty.findByDefaultValue", query = "SELECT p FROM PolicyProperty p WHERE p.defaultValue = :defaultValue")
    , @NamedQuery(name = "PolicyProperty.findByDescription", query = "SELECT p FROM PolicyProperty p WHERE p.description = :description")})
public class PolicyProperty extends DmEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    private Integer id;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 2147483647)
    private String name;
    @Size(max = 2147483647)
    private String units;
    @Size(max = 2147483647)
    @Column(name = "lower_limit")
    private String lowerLimit;
    @Size(max = 2147483647)
    @Column(name = "upper_limit")
    private String upperLimit;
    @Size(max = 2147483647)
    @Column(name = "default_value")
    private String defaultValue;
    @Size(max = 2147483647)
    private String description;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "policyPropertyId")
    private List<ExperimentPolicyPropertyValue> experimentPolicyPropertyValueList;
    @JoinColumn(name = "policy_type_id", referencedColumnName = "id")
    @ManyToOne(optional = false)
    private PolicyType policyTypeId;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "policyPropertyId")
    private List<AllowedPolicyValue> allowedPolicyValueList;

    public PolicyProperty() {
    }

    public PolicyProperty(Integer id) {
        this.id = id;
    }

    public PolicyProperty(Integer id, String name) {
        this.id = id;
        this.name = name;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getUnits() {
        return units;
    }

    public void setUnits(String units) {
        this.units = units;
    }

    public String getLowerLimit() {
        return lowerLimit;
    }

    public void setLowerLimit(String lowerLimit) {
        this.lowerLimit = lowerLimit;
    }

    public String getUpperLimit() {
        return upperLimit;
    }

    public void setUpperLimit(String upperLimit) {
        this.upperLimit = upperLimit;
    }

    public String getDefaultValue() {
        return defaultValue;
    }

    public void setDefaultValue(String defaultValue) {
        this.defaultValue = defaultValue;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @XmlTransient
    public List<ExperimentPolicyPropertyValue> getExperimentPolicyPropertyValueList() {
        return experimentPolicyPropertyValueList;
    }

    public void setExperimentPolicyPropertyValueList(List<ExperimentPolicyPropertyValue> experimentPolicyPropertyValueList) {
        this.experimentPolicyPropertyValueList = experimentPolicyPropertyValueList;
    }

    public PolicyType getPolicyTypeId() {
        return policyTypeId;
    }

    public void setPolicyTypeId(PolicyType policyTypeId) {
        this.policyTypeId = policyTypeId;
    }

    @XmlTransient
    public List<AllowedPolicyValue> getAllowedPolicyValueList() {
        return allowedPolicyValueList;
    }

    public void setAllowedPolicyValueList(List<AllowedPolicyValue> allowedPolicyValueList) {
        this.allowedPolicyValueList = allowedPolicyValueList;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof PolicyProperty)) {
            return false;
        }
        PolicyProperty other = (PolicyProperty) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "gov.anl.aps.dm.portal.model.entities2.PolicyProperty[ id=" + id + " ]";
    }
    
}
