/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.anl.aps.dm.portal.model.entities;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author sveseli
 */
@Entity
@Table(name = "user_system_role")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "UserSystemRole.findAll", query = "SELECT u FROM UserSystemRole u")
    , @NamedQuery(name = "UserSystemRole.findByUser", query = "SELECT u FROM UserSystemRole u WHERE u.userSystemRolePK.userId = :userId")
    , @NamedQuery(name = "UserSystemRole.findByRoleType", query = "SELECT u FROM UserSystemRole u WHERE u.userSystemRolePK.roleTypeId = :roleTypeId")
    , @NamedQuery(name = "UserSystemRole.findByUserAndRoleTypeAndExperimentStation", query = "SELECT u FROM UserSystemRole u WHERE u.userSystemRolePK.userId = :userId AND u.userSystemRolePK.roleTypeId = :roleTypeId AND u.experimentStation.id = :experimentStationId")
})
public class UserSystemRole extends DmEntity {

    @EmbeddedId
    protected UserSystemRolePK userSystemRolePK;
    @JoinColumn(name = "experiment_station_id", referencedColumnName = "id")
    @ManyToOne
    private ExperimentStation experimentStation;
    @JoinColumn(name = "role_type_id", referencedColumnName = "id", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private SystemRoleType systemRoleType;
    @JoinColumn(name = "user_id", referencedColumnName = "id", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private UserInfo userInfo;

    public UserSystemRole() {
    }

    public UserSystemRole(UserSystemRolePK userSystemRolePK) {
        this.userSystemRolePK = userSystemRolePK;
    }

    public UserSystemRole(int userId, int roleTypeId) {
        this.userSystemRolePK = new UserSystemRolePK(userId, roleTypeId);
    }

    public UserSystemRolePK getUserSystemRolePK() {
        return userSystemRolePK;
    }

    public void setUserSystemRolePK(UserSystemRolePK userSystemRolePK) {
        this.userSystemRolePK = userSystemRolePK;
    }

    public ExperimentStation getExperimentStation() {
        return experimentStation;
    }

    public void setExperimentStation(ExperimentStation experimentStation) {
        this.experimentStation = experimentStation;
    }

    public SystemRoleType getSystemRoleType() {
        return systemRoleType;
    }

    public void setSystemRoleType(SystemRoleType systemRoleType) {
        this.systemRoleType = systemRoleType;
    }

    public UserInfo getUserInfo() {
        return userInfo;
    }

    public void setUserInfo(UserInfo userInfo) {
        this.userInfo = userInfo;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (userSystemRolePK != null ? userSystemRolePK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof UserSystemRole)) {
            return false;
        }
        UserSystemRole other = (UserSystemRole) object;
        return !((this.userSystemRolePK == null && other.userSystemRolePK != null) || (this.userSystemRolePK != null && !this.userSystemRolePK.equals(other.userSystemRolePK)));
    }

    @Override
    public String toString() {
        return "gov.anl.aps.dm.portal.model.entities2.UserSystemRole[ userSystemRolePK=" + userSystemRolePK + " ]";
    }
    
}
