#!/usr/bin/env python

from PyQt4.QtGui import QGridLayout, QSpacerItem, QSizePolicy, QPushButton, QWidget, QFont, QLabel
from PyQt4.QtCore import QObject, Qt


# Define the experiments tab content:
class InitialTab(QWidget):
    def __init__(self, stationName, parent, id=-1):
        super(InitialTab, self).__init__(parent)
        self.stationName = stationName
        self.parent = parent
        self.initialTabLayout()

    def initialTabLayout(self):
        grid = QGridLayout()

        labelFont = QFont('Arial', 18, QFont.Bold)
        lbl = QLabel(self.stationName + ' DM Tool', self)
        lbl.setAlignment(Qt.AlignCenter)
        lbl.setFont(labelFont)
        grid.addWidget(lbl, 0, 0, 1, 7)

        grid.addItem(QSpacerItem(20, 130, QSizePolicy.Minimum, QSizePolicy.Expanding), 1, 0)

        grid.addItem(QSpacerItem(40, 20, QSizePolicy.Expanding, QSizePolicy.Minimum), 2, 0)
        manageBtn = QPushButton('Manage Experiments', self)
        manageBtn.setFixedSize(160, 160)
        manageBtn.clicked.connect(lambda: self.setTab(1))
        grid.addWidget(manageBtn, 2, 1)
        grid.addItem(QSpacerItem(40, 20, QSizePolicy.Expanding, QSizePolicy.Minimum), 2, 2)
        viewBtn = QPushButton('DAQs', self)
        viewBtn.setFixedSize(160, 160)
        viewBtn.clicked.connect(lambda: self.setTab(2))
        grid.addWidget(viewBtn, 2, 3)
        grid.addItem(QSpacerItem(40, 20, QSizePolicy.Expanding, QSizePolicy.Minimum), 2, 4)
        viewBtn = QPushButton('Uploads', self)
        viewBtn.setFixedSize(160, 160)
        viewBtn.clicked.connect(lambda: self.setTab(3))
        grid.addWidget(viewBtn, 2, 5)
        grid.addItem(QSpacerItem(40, 20, QSizePolicy.Expanding, QSizePolicy.Minimum), 2, 6)

        grid.addItem(QSpacerItem(20, 130, QSizePolicy.Minimum, QSizePolicy.Expanding), 3, 0)

        self.initialTabWidget = QWidget()
        self.initialTabWidget.setLayout(grid)

    def setTab(self, tab):
        self.parent.stackedLayout.setCurrentIndex(tab)
