#!/usr/bin/env python

from dm.common.utility.loggingManager import LoggingManager

class NoopPlatformUtility:

    def __init__(self):
        self.logger = LoggingManager.getInstance().getLogger(self.__class__.__name__)

    def createGroup(self, name):
        self.logger.debug('createGroup called for %s' % name)

    def addUserToGroup(self, username, groupName):
        self.logger.debug('addUserToGroup called for %s, %s' % (username, groupName))

    def deleteUserFromGroup(self, username, groupName):
        self.logger.debug('deleteUserFromGroup called for %s, %s' % (username, groupName))

    def createLocalGroup(self, name):
        self.logger.debug('createLocalGroup called for %s' % name)

    def addLocalUserToGroup(self, username, groupName):
        self.logger.debug('addLocalUserToGroup called for %s, %s' % (username, groupName))

    def deleteLocalUserFromGroup(self, username, groupName):
        self.logger.debug('adddeleteLocalUserFromGroup called for %s, %s' % (username, groupName))

    def getGroupInfo(self, groupName):
        self.logger.debug('getGroupInfo called for %s' % name)

    def setGroupUsers(self, groupName, usernameList):
        self.logger.debug('setGroupUsers called for %s, %s' % (groupName, usernameList))

    def setPathReadExecutePermissionsForGroup(self, path, groupName):
        self.logger.debug('setPathReadExecutePermissionsForGroup called for %s, %s' % (path, groupName))

    def changePathGroupOwner(self, path, groupName):
        self.logger.debug('changePathGroupOwner called for %s, %s' % (path, groupName))

    def recursivelyChangePathGroupOwner(self, path, groupName):
        self.logger.debug('recursivelyChangePathGroupOwner called for %s, %s' % (path, groupName))

    def refreshNscdGroupCache(self):
        self.logger.debug('refreshNscdGroupCache called')

    def refreshAuthFiles(self):
        self.logger.debug('refreshAuthFiles called')

    def chmodPathForFilesInDirectory(self, directoryPath, fileMode):
        self.logger.debug('chmodPathForFilesInDirectory called for %s, %s' % (directoryPath, fileMode))

#######################################################################
# Testing.

if __name__ == '__main__':
    pass
